{
ZWECK       : Demo Netzwerkkommunikation ber MailSlots

DATEIEN     : ms03.dpr
              ms03u1.pas
              ms03u1.dfm

STAND       : 11.4.97

AUTOR       : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 bei Kurt Spitzley, All rights reserved.
              Diese Software darf zu nichtkommerziellen Zwecken frei genutzt
              und weitergegeben werden. Kommerzielle Nutzung nur mit ausdrck-
              licher Genehmigung des Autors.
GEWHR-
LEISTUNG    : Sie akzeptieren diese Software wie sie ist, ohne eine Garantie
              jeglicher Art, einschlielich aber nicht ausschlielich der
              Eignung fr eine beliebige Anwendung.

BESCHREIBUNG: Einfacher Mailslot-Server

================================================================================

SCOPE       : Demo Network-Communication via MailSlots

FILES       : ms03.dpr
              ms03u1.pas
              ms03u1.dfm

LAST CHANGES: 11.4.97

AUTHOR      : Kurt Spitzley, email 0225438-0001@t-online.de

COPYRIGHT   : (c) 1997 by Kurt Spitzley, All rights reserved.
              This software should not be SOLD by anyone. It is distributed as
              freeware and therefore may be used free of charge.

DISCLAIMER  : You accept this software AS IS without any representation or
              warranty of any kind, including but not limited to the warranty of
              merchantability or fitness for a particular purpose.

DESCRIPTION:  Simple Mailslot-Server
}

unit ms03u1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Debwin, StdCtrls, ExtCtrls;

type
  EMailSlotError = class( Exception );

  TfrmMailslotDemo = class(TForm)
    gbReadMailslot: TGroupBox;
    lboxReadMailslot: TListBox;
    btnReadMailslot: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnReadMailslotClick(Sender: TObject);
  private
    hMailServer: THandle;
  public
    { Public-Deklarationen }
  end;

var
  frmMailslotDemo: TfrmMailslotDemo;

implementation
       
{$R *.DFM}

procedure TfrmMailslotDemo.FormCreate(Sender: TObject);
begin

  // Create a mailslot for receiving messages

  hMailServer:=CreateMailslot('\\.\mailslot\MyMailSl',
                      0,
                      0,
                      PSecurityAttributes(nil));
  if hMailServer=INVALID_HANDLE_VALUE then
    raise EMailSlotError.Create('Error creating Mailslot');
end;

procedure TfrmMailslotDemo.FormDestroy(Sender: TObject);
begin
  CloseHandle(hMailServer);
end;

procedure TfrmMailslotDemo.btnReadMailslotClick(Sender: TObject);
var
  Status: boolean;
  NextSize,
  MessageCount: dword;
  CharsRead:dword;
  s:string;
begin
  Status:=GetMailslotInfo(hMailServer,nil,NextSize,addr(MessageCount),nil);
  if NextSize<>-1 then
    begin
      SetLength(s,NextSize); // Allocate space
      ReadFile(hMailServer,PChar(s)^,NextSize,CharsRead,nil);
      SetLength(s,CharsRead); // Adjust length
    end
  else
    s:='nothing in mailslot';
  lboxReadMailSlot.Items.Add(s);
end;

end.

